/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.item.SRankListNumConfig
 *  fire.pb.main.ConfigManager
 *  fire.pb.ranklist.SRequestRankList
 *  fire.pb.ranklist.provider.IRankListData
 *  fire.pb.ranklist.provider.RankDataFactory
 *  fire.pb.title.STitleConfig
 *  fire.pb.title.TitleManager
 *  mkdb.Bean
 *  org.apache.log4j.Logger
 *  xbean.ClanProgressRankRecord
 *  xbean.ClanRankRecord
 *  xbean.ClanZongHeRankRecord
 *  xbean.PetScoreListRecord
 *  xbean.PetScoreRankList
 *  xbean.Properties
 *  xbean.RoleLevelListRecord
 *  xbean.RoleRankRecord
 *  xbean.RoleZongheRankRecord
 *  xtable.Petscorelist
 *  xtable.Properties
 */
package fire.pb.ranklist.proc;

import fire.pb.item.SRankListNumConfig;
import fire.pb.main.ConfigManager;
import fire.pb.ranklist.SRequestRankList;
import fire.pb.ranklist.proc.RankCompare;
import fire.pb.ranklist.provider.IRankListData;
import fire.pb.ranklist.provider.RankDataFactory;
import fire.pb.title.STitleConfig;
import fire.pb.title.TitleManager;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import mkdb.Bean;
import org.apache.log4j.Logger;
import xbean.ClanProgressRankRecord;
import xbean.ClanRankRecord;
import xbean.ClanZongHeRankRecord;
import xbean.PetScoreListRecord;
import xbean.PetScoreRankList;
import xbean.RoleLevelListRecord;
import xbean.RoleRankRecord;
import xbean.RoleZongheRankRecord;
import xtable.Petscorelist;
import xtable.Properties;

public class RankListManager {
    private static RankListManager _instance;
    public static final Logger logger;
    public static final int PAGE_SIZE = 20;
    private static Map<Long, Long> petOnRanklistMsgTimecheck;
    private static Object timeCheckLock;
    private static Map<Integer, SRankListNumConfig> personNumConfig;

    /*
     * WARNING - Removed try catching itself - possible behaviour change.
     */
    public boolean checkPetOnRanklistMsgTimeSpace(long roleid) {
        Object object = timeCheckLock;
        synchronized (object) {
            Long lastTime = petOnRanklistMsgTimecheck.get(roleid);
            if (null == lastTime) {
                petOnRanklistMsgTimecheck.put(roleid, System.currentTimeMillis());
                return true;
            }
            long timeSpace = System.currentTimeMillis() - lastTime;
            if (timeSpace < 300000L) {
                return false;
            }
            if (petOnRanklistMsgTimecheck.size() > 100) {
                this.clearPetOnRankListTick();
            }
            petOnRanklistMsgTimecheck.put(roleid, System.currentTimeMillis());
        }
        return true;
    }

    private void clearPetOnRankListTick() {
        Iterator<Map.Entry<Long, Long>> iterator = petOnRanklistMsgTimecheck.entrySet().iterator();
        ArrayList<Long> removeList = new ArrayList<Long>();
        while (iterator.hasNext()) {
            Map.Entry<Long, Long> current = iterator.next();
            long timeSpace = System.currentTimeMillis() - current.getValue();
            if (timeSpace <= 300000L) continue;
            removeList.add(current.getKey());
        }
        for (Long roleid : removeList) {
            petOnRanklistMsgTimecheck.remove(roleid);
        }
    }

    private RankListManager() {
    }

    /*
     * WARNING - Removed try catching itself - possible behaviour change.
     */
    public static RankListManager getInstance() {
        Class<RankListManager> clazz = RankListManager.class;
        synchronized (RankListManager.class) {
            if (null == _instance) {
                _instance = new RankListManager();
            }
            // ** MonitorExit[var0] (shouldn't be in output)
            return _instance;
        }
    }

    public boolean tryInsertRecord(int recordType, List listRecord, Bean newRecord) {
        if (newRecord instanceof RoleLevelListRecord && recordType != 1) {
            return false;
        }
        if (newRecord instanceof RoleZongheRankRecord && recordType != 32) {
            return false;
        }
        if (newRecord instanceof RoleRankRecord && recordType != 38) {
            return false;
        }
        if (newRecord instanceof ClanRankRecord && recordType != 49) {
            return false;
        }
        if (newRecord instanceof ClanZongHeRankRecord && recordType != 50) {
            return false;
        }
        if (newRecord instanceof ClanProgressRankRecord && recordType != 70) {
            return false;
        }
        int personNum = this.getPersonNumMaxByType(recordType);
        return this.tryInsertRoseRecord(recordType, personNum, listRecord, newRecord);
    }

    private boolean tryInsertRoseRecord(int recordType, int personNum, List listRecord, Bean newRecord) {
        PetScoreListRecord r;
        boolean removeMyself = false;
        boolean onRanklist = true;
        int rankSize = listRecord.size();
        if (rankSize == 0) {
            if (recordType == 9) {
                PetScoreListRecord r2 = (PetScoreListRecord)newRecord;
                if (r2.getMarshaldata().getPetgrade() >= 2000) {
                    listRecord.add(newRecord);
                }
                return true;
            }
            listRecord.add(newRecord);
            return true;
        }
        int myIndex = -1;
        for (int i = 0; i < rankSize; ++i) {
            Bean current = (Bean)listRecord.get(i);
            if (!RankCompare.isSame(current, newRecord)) continue;
            myIndex = i;
            break;
        }
        Bean oldMyRecord = null;
        if (myIndex != -1) {
            Bean temp;
            if (recordType == 70) {
                oldMyRecord = (Bean)listRecord.get(myIndex);
            }
            if (!RankCompare.isReplace(temp = (Bean)listRecord.get(myIndex), newRecord)) {
                return false;
            }
            listRecord.remove(myIndex);
            removeMyself = true;
        }
        boolean del = false;
        if (recordType == 9 && (r = (PetScoreListRecord)newRecord).getMarshaldata().getPetgrade() < 2000) {
            onRanklist = false;
            del = true;
        }
        if (!del) {
            if (listRecord.size() == 0) {
                if (recordType == 70 && !RankCompare.CompareTo(newRecord, oldMyRecord)) {
                    listRecord.add(oldMyRecord);
                    return false;
                }
                listRecord.add(newRecord);
                return false;
            }
            for (int i = listRecord.size() - 1; i >= 0; --i) {
                Bean befor = (Bean)listRecord.get(i);
                if (recordType == 70 && oldMyRecord != null && !RankCompare.CompareTo(newRecord, oldMyRecord)) {
                    newRecord = oldMyRecord;
                }
                if (!RankCompare.CompareTo(newRecord, befor)) {
                    listRecord.add(i + 1, newRecord);
                    if (i + 2 <= personNum) break;
                    onRanklist = false;
                    break;
                }
                if (i != 0) continue;
                listRecord.add(i, newRecord);
            }
        }
        if (listRecord.size() > personNum) {
            listRecord.remove(personNum);
        }
        return !removeMyself && onRanklist;
    }

    public int getPersonNumMaxByType(int type) {
        SRankListNumConfig config = personNumConfig.get(type);
        if (null == config) {
            return 0;
        }
        return config.getPersonNum();
    }

    public String getNameByType(int type) {
        SRankListNumConfig config = personNumConfig.get(type);
        if (null == config) {
            return null;
        }
        return config.getNamename();
    }

    public SRequestRankList getRankListResponse(int ranktype, long requestRole, int page) {
        SRequestRankList response = new SRequestRankList();
        response.ranktype = ranktype;
        this.setRankListOctets(response, ranktype, requestRole, page);
        return response;
    }

    private void setRankListOctets(SRequestRankList response, int ranktype, long requestRole, int page) {
        IRankListData provider = RankDataFactory.getInstance().createRankProvider(ranktype, requestRole);
        if (null == provider) {
            response.hasmore = 1;
            return;
        }
        List octets = provider.getMO(response, page);
        if (null == octets) {
            response.hasmore = 1;
            return;
        }
        response.list.addAll(octets);
    }

    public String getRankTitleByRank(long roleid, int rank, int ranktype) {
        int titleId = 0;
        if (0 != titleId) {
            STitleConfig title = TitleManager.getTitleConfigById((int)titleId);
            if (null == title) {
                return "----";
            }
            return title.getTitlename();
        }
        return "----";
    }

    public static boolean isAddRankList(long roleid, boolean isAdd) {
        xbean.Properties role = Properties.get((Long)roleid);
        if (null == role) {
            return false;
        }
        role.setAddranklist(isAdd);
        return true;
    }

    public static boolean isPetRanklistRecord(long uniquePetId, int rankNum) {
        int rankid = RankListManager.getPetRankidByUniqueID(uniquePetId);
        if (-1 == rankid) {
            return false;
        }
        return rankid <= rankNum;
    }

    public static int getPetRankidByUniqueID(long uniquiPetId) {
        PetScoreRankList list = Petscorelist.select((Integer)1);
        if (null == list) {
            return -1;
        }
        int counter = 1;
        for (PetScoreListRecord record : list.getRecords()) {
            if (record.getMarshaldata().getUniquepetid() == uniquiPetId) {
                return counter;
            }
            ++counter;
        }
        return -1;
    }

    public static long GetMonday1Millisecond() {
        Calendar cal = Calendar.getInstance();
        if (cal.get(7) == 1) {
            cal.add(5, -6);
            cal.set(11, 0);
            cal.set(12, 0);
            cal.set(13, 0);
            cal.set(14, 1);
        } else {
            int c = cal.get(7);
            int tmp = 7 - c - 5;
            cal.add(5, tmp);
            cal.set(11, 0);
            cal.set(12, 0);
            cal.set(13, 0);
            cal.set(14, 1);
        }
        return cal.getTimeInMillis();
    }

    static {
        logger = Logger.getLogger((String)"RANKLIST");
        petOnRanklistMsgTimecheck = new HashMap<Long, Long>();
        timeCheckLock = new Object();
        personNumConfig = ConfigManager.getInstance().getConf(SRankListNumConfig.class);
    }
}

